程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> HDU 1298 T9(手機輸入法相關,字典樹+dfs)

HDU 1298 T9(手機輸入法相關,字典樹+dfs)

編輯:C++入門知識

題目:

Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.


More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this word is not listed in the dictionary.
 

Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".
 

Output
The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.
 

Sample Input
2
5
hell 3
hello 4
idea 8
next 8
super 3
2
435561
43321
7
another 5
contest 6
follow 3
give 13
integer 6
new 14
program 4
5
77647261
6391
4681
26684371
77771
 

Sample Output
Scenario #1:
i
id
hel
hell
hello

i
id
ide
idea


Scenario #2:
p
pr
pro
prog
progr
progra
program

n
ne
new

g
in
int

c
co
con
cont
anoth
anothe
another

p
pr
MANUALLY
MANUALLY
 


題目大意:
在以前,手機輸入法很麻煩,因為只有9個鍵,而字母有26個,所以一個鍵上同時包含這幾個字母,這樣的話,為了打出一個字母可能要按幾次。比如鍵5有“JKL”, 如果要輸入K,那麼就要連按兩次。
這樣的輸入法很麻煩。所以一家公司發明了T9技術輸入法。這種輸入法內置這很多英語單詞,它可以根據英語出現的頻率,是否存在等信息,每個字母只要按一次,就可以有想要的預選單詞。
例如,假設輸入法只內置了一個單詞“hell”, 那麼只需要按4355便可以出來。
注意,如果有一個單詞hell, 那麼這個單詞的所有前綴,h, he, hel, 也當作是存在的。

 

分析與總結:
這題貌似和實際應用關系還是挺大。
按照要求建好字典樹,插入一個單詞時,一路下去都要加上頻率p.
然後就是要用dfs,求出頻率最大的那個單詞輸出。

做這題時,沒想到竟然1A了,笑死

 


代碼:
[cpp] 
#include<iostream> 
#include<cstdio> 
#include<cstring> 
#include<vector> 
using namespace std; 
 
const int KIND = 26; 
const int MAXN = 15000; 
int cnt_node; 
 
vector<int>g[10]; 
char input[105]; 
char ans[105]; 
int num, Max; 
bool flag; 
 
struct node{ 
    int prefix; 
    node *next[KIND]; 
    void init(){ 
        prefix=0; 
        memset(next, 0, sizeof(next)); 
    } 
}Heap[MAXN]; 
 
inline node* newNode(){ 
    Heap[cnt_node].init(); 
    return &Heap[cnt_node++]; 

void insert(node *root, char *str, int n){ 
    for(char *p=str; *p; ++p){ 
        int ch=*p-'a'; 
        if(root->next[ch]==NULL) 
            root->next[ch] = newNode(); 
        root = root->next[ch]; 
        root->prefix += n; 
    } 

void dfs(node *root, char *str, int pos){ //str保存輸出結果 
    if(root==NULL)return; 
    if(pos >= num){ 
        if(root->prefix > Max){ 
            strcpy(ans, str); 
            Max=root->prefix; 
        }  
        flag=true; 
        return ; 
    } 
    int u=input[pos]-'0'; 
    for(int i=0; i<g[u].size(); ++i){ 
        str[pos] = g[u][i]+'a'; 
        dfs(root->next[g[u][i]], str, pos+1); 
        str[pos] = 0; 
    } 

 
int main(){ 
    int T,n,p,cas=1; 
    char str[105]; 
 
    // 鍵盤設置, 貌似這樣寫復雜了... 
    for(int i=0; i<10; ++i) g[i].clear(); 
    g[2].push_back(0), g[2].push_back(1), g[2].push_back(2); 
    g[3].push_back(3), g[3].push_back(4), g[3].push_back(5); 
    g[4].push_back(6), g[4].push_back(7), g[4].push_back(8); 
    g[5].push_back(9), g[5].push_back(10), g[5].push_back(11); 
    g[6].push_back(12), g[6].push_back(13), g[6].push_back(14); 
    g[7].push_back(15), g[7].push_back(16), g[7].push_back(17),g[7].push_back(18); 
    g[8].push_back(19), g[8].push_back(20), g[8].push_back(21); 
    g[9].push_back(22), g[9].push_back(23), g[9].push_back(24), g[9].push_back(25); 
 
    scanf("%d",&T); 
    while(T--){ 
        scanf("%d",&n); 
        printf("Scenario #%d:\n", cas++); 
         
        // Trie init 
        cnt_node=0; 
        node *root = newNode(); 
 
        for(int i=0; i<n; ++i){ 
            scanf("%s %d",str,&p); 
            insert(root, str, p); 
        } 
 
        scanf("%d",&n); 
        for(int i=0; i<n; ++i){ 
            scanf("%s", input); 
            for(int j=0; j<strlen(input)-1; ++j){ 
                memset(str, 0, sizeof(str)); 
                Max=-1; 
                num=j+1; 
                flag=false; 
                dfs(root, str, 0); 
                if(flag) puts(ans); 
                else puts("MANUALLY"); 
            } 
            puts(""); 
        } 
        puts(""); 
    }   
    return 0; 

  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved